H - By Elevator or Stairs? CodeForces - 1249E

You are planning to buy an apartment in a nn -floor building. The floors are numbered from 11 to nn from the bottom to the top. At first for each floor you want to know the minimum total time to reach it from the first (the bottom) floor.

Let:

  • aiai for all ii from 11 to n−1n−1 be the time required to go from the ii -th floor to the (i+1)(i+1) -th one (and from the (i+1)(i+1) -th to the ii -th as well) using the stairs;
  • bibi for all ii from 11 to n−1n−1 be the time required to go from the ii -th floor to the (i+1)(i+1) -th one (and from the (i+1)(i+1) -th to the ii -th as well) using the elevator, also there is a value cc — time overhead for elevator usage (you need to wait for it, the elevator doors are too slow!).

In one move, you can go from the floor you are staying at xx to any floor yy (x≠yx≠y ) in two different ways:

  • If you are using the stairs, just sum up the corresponding values of aiai . Formally, it will take ∑i=min(x,y)max(x,y)−1ai∑i=min(x,y)max(x,y)−1ai time units.
  • If you are using the elevator, just sum up cc and the corresponding values of bibi . Formally, it will take c+∑i=min(x,y)max(x,y)−1bic+∑i=min(x,y)max(x,y)−1bi time units.

You can perform as many moves as you want (possibly zero).

So your task is for each ii to determine the minimum total time it takes to reach the ii -th floor from the 11 -st (bottom) floor.

Input

The first line of the input contains two integers nn and cc (2≤n≤2⋅105,1≤c≤10002≤n≤2⋅105,1≤c≤1000 ) — the number of floors in the building and the time overhead for the elevator rides.

The second line of the input contains n−1n−1 integers a1,a2,…,an−1a1,a2,…,an−1 (1≤ai≤10001≤ai≤1000 ), where aiai is the time required to go from the ii -th floor to the (i+1)(i+1) -th one (and from the (i+1)(i+1) -th to the ii -th as well) using the stairs.

The third line of the input contains n−1n−1 integers b1,b2,…,bn−1b1,b2,…,bn−1 (1≤bi≤10001≤bi≤1000 ), where bibi is the time required to go from the ii -th floor to the (i+1)(i+1) -th one (and from the (i+1)(i+1) -th to the ii -th as well) using the elevator.

Output

Print nn integers t1,t2,…,tnt1,t2,…,tn , where titi is the minimum total time to reach the ii -th floor from the first floor if you can perform as many moves as you want.

Examples

Input

10 2
7 6 18 6 16 18 1 17 17
6 9 3 10 9 1 10 1 5

Output

0 7 13 18 24 35 36 37 40 45 

Input

10 1
3 2 3 1 3 3 1 4 1
1 2 3 4 4 1 2 1 3

Output

0 2 4 7 8 11 13 14 16 17 

思路:

dp题:二维数组dp[i][j],表示通过 j 的方法( j = 0 表示楼梯,j = 1表示电梯)第 i 层所需的最少时间。
可以看出有四种状态,

转换非常容易:
dpi+1,0=min(dpi+1,0,dpi,0+ai)(我们当时不在电梯里,正在下一层楼梯上);
dpi+1,0=min(dpi+1,0,dpi,1+ai)(我们当时在电梯里,正在下一层楼梯上);
dpi+1,1=min(dpi+1,1,dpi,0+bi+c)(我们不在电梯里,乘电梯去下一层);
dpi+1,1=min(dpi+1,1,dpi,1+bi)(我们在电梯里,乘电梯去了下一层)。

所以得出状态转移方程
dp[i+1][0]=min(dp[i][1]+a[i],dp[i][0]+a[i]);
dp[i+1][1]=min(dp[i][1]+b[i],dp[i][0]+b[i]+c);

代码如下:

#include<stdio.h>
#include<string.h>
#include<algorithm>
using namespace std;
int n,c;
int a[220000],b[220000];
int dp[220000][10];
int main()
{
    while(~scanf("%d %d",&n,&c))
    {
        for(int i=1;i<n;i++)
            scanf("%d",&a[i]);
        for(int i=1;i<n;i++)
            scanf("%d",&b[i]);
        dp[1][0]=c;
        dp[1][1]=0;
        for(int i=2;i<=n;i++)
        {
            dp[i][0]=min(dp[i-1][0]+b[i-1],dp[i-1][1]+c+b[i-1]);
            dp[i][1]=min(dp[i-1][0]+a[i-1],dp[i-1][1]+a[i-1]);///dp[i][1]=min(dp[i-1][0],dp[i-1][1])+a[i-1];这里不转换+C因为电梯到电梯直接上去了
        }
        printf("0");
        for(int i=2;i<=n;i++)
            printf(" %d",min(dp[i][0],dp[i][1]));
        printf("\n");
    }
    return 0;
}

 

  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值